leetcode-292. Nim Game

来源:互联网 发布:codol过一会就数据异常 编辑:程序博客网 时间:2024/06/06 03:44

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.
题目:你和你朋友在玩如下的Nim游戏:在桌上有一堆石头,你俩每次从中移出1到3块石头。谁移动最后一块石头就赢了。首先由你来移动石头。

你俩都很聪明,同时对这个游戏都有最佳的策略。写一个函数来确定对于给定数量的石头你是否可以赢得比赛。

例如,如果堆中有4块石头,那么你永远无法赢得比赛:不管你移动1块,2块,或3块时候,最后 y块石头总是被你朋友移走。

解法:乍一看这个题目有点复杂。但是当你看一下它给的例子。你会发现,只要最后剩4块石头,你就无法赢。那么剩8块,12块,16块。。。也是如此。因为你和你的朋友都是这个游戏的高手啊,所以只要石头的数量是4的倍数时,你就永远无法赢得这个比赛。代码如下

public class Solution {    public boolean canWinNim(int n) {        return n % 4 != 0;    }}
0 0
原创粉丝点击